<?php

namespace AppBundle\Controller;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\StreamedResponse;
use Symfony\Component\HttpFoundation\JsonResponse;
use AppBundle\Model\SubsFormat\Subtitle as Subtitle;
use AppBundle\Model\SubsFormat\SubtitleForText as SubtitleForText;



class ExportTextController extends Controller
{

	/**
    * @Route("/export/text/{textFormat}", name="exportText")
    * @Method ({"POST"})
    */
    public function exportAction(Request $request, $textFormat)
    {

    	if ($request->getMethod() == 'POST') {

    		//Recuperem dades
 
    		$data = $request->request->all();

   			// SUBTITLE LIST
            
    		$OriginalFilename= $data['filename'];

            $subslength = count($data['subtitle']['id']);

            for ($x = 0; $x < $subslength; $x++) {
                $id = $data['subtitle']['id'][$x];
                $tcIn = $data['subtitle']['tcIn'][$x];
                $tcOut = $data['subtitle']['tcOut'][$x];

                if (isset($data['subtitle']['italic'][($data['subtitle']['id'][$x])])) {
                    $italic = true;
                } else {
                    $italic = false;
                }

                if (isset($data['subtitle']['highlight'][($data['subtitle']['id'][$x])])) {
                    $highlight = true;
                } else {
                    $highlight = false;
                }

                $text = $data['subtitle']['text'][$x];

                if (isset($data['subtitle']['textTrans'][$x])) {
	            	$textTrans = $data['subtitle']['textTrans'][$x];
                } else {
                	$textTrans = '';
                }

	            $subtitlesList[] = new SubtitleForText($id, $tcIn, $tcOut, $text, $italic, $textTrans, $highlight);
            }

		

			//SWITCH FORMAT DE TEXT

    		switch ($textFormat) {


    			case 'pdf':
    				switch ($data['exportColumnText']) {
	                	case 'subtitle':
	                		$content = $this->renderView('exportPdf/listSubsPdf.html.twig', array(
	    						'subtitles' => $subtitlesList,
	    						'filename' => $OriginalFilename,	    						

	    						));

	                		break;
	                	
	                	case 'translation':
	                		foreach ($subtitlesList as $subs)
		  					$content =  $this->renderView('exportPdf/listTranslationPdf.html.twig', array(
			    				'subtitles' => $subtitlesList,
			    				'filename' => $OriginalFilename,
			    				));

	                		break;
	                	case 'both':
		                	foreach ($subtitlesList as $subs)
		  					{
		  						$content =  $this->renderView('exportPdf/listBothPdf.html.twig', array(
				    				'subtitles' => $subtitlesList,
				    				'filename' => $OriginalFilename));

		  					}
	                		break;
                	}
    				  			
	

                	$pdf = $this->get('white_october.tcpdf')->create('c');

	    			//$pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
					
	    			/*
					$pdf ->SetAuthor('Subconverter');
					$pdf ->SetTitle('Subtitles List');
					// activa o desactiva encabezado de página
					$pdf ->SetPrintHeader(false);
					// activa o desactiva el pie de página
					$pdf ->SetPrintFooter(false);
					// set default font subsetting mode
					$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
						$pdf ->SetPrintHeader(false);
					*/
					$pdf ->SetPrintHeader(false);
					$pdf->setFontSubsetting(false);
					$pdf->SetFont('freeserif', '', 9);
					
					//$pdf->setPageOrientation("H");
					// set default header data
					//$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE.' 001',PDF_HEADER_STRING, array(0,64,255), array(0,64,128));
					/*
					$pdf->setFooterData(array(0,64,0), array(0,64,128));
					// set header and footer fonts
					
					$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
					$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));
					// set default monospaced font
					//$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
					// set margins
					$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
					//$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
					$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
					// set auto page breaks
					$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
					*/
					$pdf ->AddPage();
					$pdf->writeHTMLCell(0, 0, '', '', $content, 0, 1, 0, true, '', true );
					// clean buffer
					ob_end_clean();
					$pdf->Output('Subtitle_Converter_New.pdf', 'D');

					
					break;
    			

    			case 'csv':
    				// Activate line endings detect
    				ini_set("auto_detect_line_endings", true);

    				$filename = 'Subtitle_Converter_New.csv';
    				$file = fopen($filename,"w");

    				//Define Boom for Excell compatibility	
    				fputs($file, $bom = (chr(0xEF).chr(0xBB).chr(0xBF)));


                	switch ($data['exportColumnText']) {
	                	case 'subtitle':
	                		foreach ($subtitlesList as $subs)
		  					{
		  						$line = array($subs->getId(), $subs->getTcIN(),  $subs->getTcOut(), $subs->getText());
		  						fputcsv($file, $line, ',','"');
		  					}
	                		break;
	                	
	                	case 'translation':
	                		foreach ($subtitlesList as $subs)
		  					{
		  						$line = array($subs->getId(), $subs->getTcIN(),  $subs->getTcOut(), $subs->getTranslation());
		  						fputcsv($file, $line, ',','"');
		  					}
	                		break;
	                	case 'both':
		                	foreach ($subtitlesList as $subs)
		  					{
		  						$line = array($subs->getId(), $subs->getTcIN(),  $subs->getTcOut(), $subs->getText(), $subs->getTranslation());
		  						fputcsv($file, $line, ',','"');
		  					}
	                		break;
                	}

					fclose($file);

					$response = new Response();

					// Set headers
					$response->headers->set('Cache-Control', 'private');
					$response->headers->set('Content-type', mime_content_type($filename));
					$response->headers->set('Content-Disposition', 'attachment; filename="'.basename($filename).'";');
					$response->headers->set('Content-length', filesize($filename));

					// Send headers before outputting anything
					$response->sendHeaders();
					$response->setContent(file_get_contents($filename));

					return $response;
    				break;
    				
 
    		}


		}

    }

}
