<?php

namespace AppBundle\Controller;


use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\JsonResponse;
use AppBundle\Entity\FCP7Param;

class ParameterController extends Controller
{
    


    /**
     * @Route("/parameterList/", 
     *name="parameterList")
     */
    public function ParameterListAction(Request $request, $format, $userId=null, $selected=null)
    {
    
        switch ($format) {
            case 'fcp7':

                $em = $this->getDoctrine()->getManager(); 

                $systemOptions = $em->getRepository('AppBundle:FCP7Param')->findBy(array(
                    'user' => 1));

                if (null === $userId) {
                    return $this->render('parameter/parameterList.html.twig', array('systemOptions' => $systemOptions, 'selected' => $selected ));
                } else {
                    $em = $this->getDoctrine()->getManager(); 
                    $userOptions = $em->getRepository('AppBundle:FCP7Param')->findBy(array('user' => $userId));

                    return $this->render('parameter/parameterUserList.html.twig', array('systemOptions' => $systemOptions, 'userOptions' => $userOptions, 'selected' => $selected ));
                }   

                break;
            
            default:
                # code...
                break;
        }

    }

    /**
     *@Route("/parameterList/content/{format}/{paramId}", 
     *name="parameterListContentAjax",
     *options={"expose"=true},  
     *condition="request.isXmlHttpRequest()")
     */
    public function LoadParameterListContentAjaxAction(Request $request, $format, $paramId)
    {
        
        
        switch ($format) {
            case 'fcp7':

                $em = $this->getDoctrine()->getManager(); 
                $param = $em->find('AppBundle:FCP7Param', $paramId);
                
                $template = $this->render('format/'.$format.'StyleSettings.html.twig', array('param' => $param))->getContent();

                return  new JsonResponse($template);    


            default:
                # code...
                break;
        }

    }

     /**
     *@Route("/parameterList/{format}/{paramId}", 
     *name="parameterListContent",
     *options={"expose"=true})  
     *
     */

    public function LoadParameterListContentAction(Request $request, $format, $paramId)
    {
          
        switch ($format) {
            case 'fcp7':

                $em = $this->getDoctrine()->getManager(); 
                $param = $em->find('AppBundle:FCP7Param', $paramId);
                
                $template = $this->render('format/'.$format.'StyleSettings.html.twig', array('param' => $param));

                return  $template;    


            default:
                # code...
                break;
        }

    }


    /**
     *@Route("/exist/param", 
     *name="existParamName",
     *options={"expose"=true},
     *condition="request.isXmlHttpRequest()")  
     */

    public function existParamName(Request $request){

        $data = $request->request->all();
        $paramName =  $data['paramName'];
        $format =  $data['format'];

        $em = $this->getDoctrine()->getManager(); 
        $param = $em->getRepository('AppBundle:FCP7Param')->findOneBy(array(
                      'name' => $paramName));

        if (!$param) {
            return new JsonResponse(false);
        } 
        else {
            return new JsonResponse(true);
        }

         
    }

    /**
     *@Route("/parameterList/add/{format}/{userId}", 
     *name="addParam",
     *options={"expose"=true},
     *condition="request.isXmlHttpRequest()")  
     */

    public function addParameterAction(Request $request, $format, $userId )
    {

        
        $data = $request->request->all();
        $name =  $data['name'];
        $em = $this->getDoctrine()->getManager(); 
        $user = $em->find('AppBundle:User', $userId);
        //Transform params serialize() to Array 
        parse_str($data['param'], $params);


        switch ($format) {
            case 'fcp7':

            $param = new FCP7Param();
            $param->setName($name);
            $param->setTypo($params['typo']);

            if ($params['typoCustom'] != '') $param->setCustomTypo($params['typoCustom']);

            $param->setTextSize($params['textSize']);
            $param->setTextStyle($params['textStyle']);
            $param->setAlignment($params['alignment']);
            $param->setTracking($params['tracking']);
            $param->setTextLeading($params['textLeading']);
            $param->setAspect($params['aspect']);
            $param->setTextOpacity($params['textOpacity']);

            if ($params['sameLine'] == 'true') {
                $param->setSameLine(1);
                $param->setCenterXone($params['centerXtwo']);
                $param->setCenterYone($params['centerYtwo']);
                $param->setCenterXtwo($params['centerXtwo']);
                $param->setCenterYtwo($params['centerYtwo']);
            } else {
                $param->setSameLine(0);
                $param->setCenterXone($params['centerXone']);
                $param->setCenterYone($params['centerYone']);
                $param->setCenterXtwo($params['centerXtwo']);
                $param->setCenterYtwo($params['centerYtwo']);
            }
            
            $param->setTextColor($params['textColor']);
            $param->setColorAlpha($params['colorAlpha']);
            $param->setLineWidth($params['lineWidth']);
            $param->setLineSoftness($params['lineSoftness']);
            $param->setOutColor($params['outColor']);
            $param->setOutColorAlpha($params['outColorAlpha']);
            $param->setXScale($params['xScale']);
            $param->setYScale($params['yScale']);
            $param->setXOffset($params['xOffset']);
            $param->setYOffset($params['yOffset']);
            $param->setBackSoft($params['backSoft']);
            $param->setBackOpacity($params['backOpacity']);
            $param->setBackColor($params['backColor']);
            $param->setBackColorAlpha($params['backColorAlpha']);

            if ($params['kern'] == 'TRUE') $param->setKern(1);
            else $param->setKern(0);
            if ($params['crop'] == 'TRUE') $param->setCrop(1);
            else $param->setCrop(0);

            $param->setUser($user);


            //$em = $this->getDoctrine()->getManager();
            $em->persist($param);
            $flush = $em->flush();

            if ($flush == null) {
                //$param->setId(4);
                $message = "Your preset ".$name." was created successfully and now is selected!";
                $success = true;
            } else {
                $message = "An error has been occurred. Your setting ".$name." could not be saved to database!";
                $success = false;
                $param->setId(4);
            }

            $template = $this->render('format/'.$format.'StyleSettings.html.twig', array('param' => $param, 'message' => $message, 'success'=> $success))->getContent();

                return  new JsonResponse($template);    

        }

    }

    /**
     *@Route("/parameterList/delete/{format}/{userId}/{paramId}", 
     *name="deleteParam",
     *options={"expose"=true},
     *condition="request.isXmlHttpRequest()")  
     */

    public function deleteParameterAction(Request $request, $format, $userId, $paramId)
    {

        $data = $request->request->all();
        $paramName =  $data['paramName'];

        switch ($format) {
            case 'fcp7':

                $em = $this->getDoctrine()->getManager();
                $param = $em->getRepository('AppBundle:FCP7Param')->findOneBy(array(
                      'id' => $paramId, 'user' => $userId));

                if (!$param) {
                    $message = "An error has been occurred! Impossible to delete ".$paramName." preset!"; 
                    $success = false; 
                    $param = $em->find('AppBundle:FCP7Param', $paramId);
  

                } else {

                    $em->remove($param);
                    $flush = $em->flush();

                    if ($flush == null) {
                        $message = "The preset ".$paramName." has been deleted successfully!";
                        $success = true;
                        $param = $em->find('AppBundle:FCP7Param', 4);
                    }   
                }
        

                $template = $this->render('format/'.$format.'StyleSettings.html.twig', array('param' => $param, 'message' => $message, 'success'=> $success))->getContent();
                return  new JsonResponse($template);    
            


            default:
                # code...
                break;
        }



    }

    /**
     *@Route("/parameterList/update/{format}/{userId}/{paramId}", 
     *name="updateParam",
     *options={"expose"=true},
     *condition="request.isXmlHttpRequest()")  
     */

     public function updateParameterAction(Request $request, $format, $userId, $paramId)
    {

        
        $data = $request->request->all();
       
        //$format = $data['format'];
        $paramName =  $data['paramName'];
        //$userId =  $data['user'];
        //$paramId = $data['paramId'];
        //Transform serialize() to Array 
        parse_str($data['param'], $params);


        switch ($format) {
            case 'fcp7':

            $em = $this->getDoctrine()->getManager();
            $param = $em->getRepository('AppBundle:FCP7Param')->findOneBy(array(
                      'id' => $paramId,'user' => $userId));

            

           
            if (!$param) {
                    $message = "Impossible to update ".$paramName." preset!";
                    $success = false;
                    $param = $em->find('AppBundle:FCP7Param', $paramId);
  

            } else {


                //$param->setName($name);

                $param->setTypo($params['typo']);
            
                if ($params['typoCustom'] != '') $param->setCustomTypo($params['typoCustom']);

                $param->setTextSize($params['textSize']);
                $param->setTextStyle($params['textStyle']);
                $param->setAlignment($params['alignment']);
                $param->setTracking($params['tracking']);
                $param->setTextLeading($params['textLeading']);
                $param->setAspect($params['aspect']);
                $param->setTextOpacity($params['textOpacity']);

                if ($params['sameLine'] == 'true') {
                    $param->setSameLine(1);
                    $param->setCenterXone($params['centerXtwo']);
                    $param->setCenterYone($params['centerYtwo']);
                    $param->setCenterXtwo($params['centerXtwo']);
                    $param->setCenterYtwo($params['centerYtwo']);
                } else {
                    $param->setSameLine(0);
                    $param->setCenterXone($params['centerXone']);
                    $param->setCenterYone($params['centerYone']);
                    $param->setCenterXtwo($params['centerXtwo']);
                    $param->setCenterYtwo($params['centerYtwo']);
                }
                
                $param->setTextColor($params['textColor']);
                $param->setColorAlpha($params['colorAlpha']);
                $param->setLineWidth($params['lineWidth']);
                $param->setLineSoftness($params['lineSoftness']);
                $param->setOutColor($params['outColor']);
                $param->setOutColorAlpha($params['outColorAlpha']);
                $param->setXScale($params['xScale']);
                $param->setYScale($params['yScale']);
                $param->setXOffset($params['xOffset']);
                $param->setYOffset($params['yOffset']);
                $param->setBackSoft($params['backSoft']);
                $param->setBackOpacity($params['backOpacity']);
                $param->setBackColor($params['backColor']);
                $param->setBackColorAlpha($params['backColorAlpha']);

                if ($params['kern'] == 'TRUE') $param->setKern(1);
                else $param->setKern(0);
                if ($params['crop'] == 'TRUE') $param->setCrop(1);
                else $param->setCrop(0);


                $flush = $em->flush();


                if ($flush == null) {
                    $message = "Your preset ".$paramName." has been updated successfully and now is selected!";
                    $success = true;
                } else {
                    $message = "An error has occurred. Your preset ".$paramName." could not be updated to database!"; 
                    $success = false;
                   
                }
            }
             
            $template = $this->render('format/'.$format.'StyleSettings.html.twig', array('param' => $param, 'message' => $message, 'success' => $success))->getContent();

                return  new JsonResponse($template);    

        }

    }





}
