<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * FCP7Param
 *
 * @ORM\Table(name="fcp7param")
 * @ORM\Entity(repositoryClass="AppBundle\Repository\FCP7ParamRepository")
 */
class FCP7Param
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=255)
     */
    private $name;

    /**
     * @var string
     *
     * @ORM\Column(name="typo", type="string", length=255)
     */
    private $typo;

    /**
     * @var string
     *
     * @ORM\Column(name="customTypo", type="string", length=255, nullable=true)
     */
    private $customTypo;

    /**
     * @var string
     *
     * @ORM\Column(name="textSize", type="float")
     */
    private $textSize;

    /**
     * @var int
     *
     * @ORM\Column(name="textStyle", type="smallint")
     */
    private $textStyle;

    /**
     * @var int
     *
     * @ORM\Column(name="alignment", type="smallint")
     */
    private $alignment;

    /**
     * @var string
     *
     * @ORM\Column(name="tracking", type="float")
     */
    private $tracking;

    /**
     * @var string
     *
     * @ORM\Column(name="textLeading", type="float")
     */
    private $textLeading;

    /**
     * @var string
     *
     * @ORM\Column(name="aspect", type="float")
     */
    private $aspect;

    /**
     * @var string
     *
     * @ORM\Column(name="textOpacity", type="float")
     */
    private $textOpacity;


      /**
     * @var boolean
     *
     * @ORM\Column(name="sameLine", type="boolean")
     */
    private $sameLine;

    /**
     * @var string
     *
     * @ORM\Column(name="centerXone", type="float")
     */
    private $centerXone;

    /**
     * @var string
     *
     * @ORM\Column(name="centerYone", type="float")
     */
    private $centerYone;

    /**
     * @var string
     *
     * @ORM\Column(name="centerXtwo", type="float")
     */
    private $centerXtwo;

    /**
     * @var string
     *
     * @ORM\Column(name="centerYtwo", type="float")
     */
    private $centerYtwo;



    /**
     * @var string
     *
     * @ORM\Column(name="textColor", type="string", length=15)
     */
    private $textColor;

    /**
     * @var int
     *
     * @ORM\Column(name="colorAlpha", type="smallint")
     */
    private $colorAlpha;

    /**
     * @var string
     *
     * @ORM\Column(name="lineWidth", type="float")
     */
    private $lineWidth;

    /**
     * @var string
     *
     * @ORM\Column(name="lineSoftness", type="float")
     */
    private $lineSoftness;

    /**
     * @var string
     *
     * @ORM\Column(name="outColor", type="string", length=15)
     */
    private $outColor;

    /**
     * @var int
     *
     * @ORM\Column(name="outColorAlpha", type="smallint")
     */
    private $outColorAlpha;

    /**
     * @var string
     *
     * @ORM\Column(name="xScale", type="float")
     */
    private $xScale;

    /**
     * @var string
     *
     * @ORM\Column(name="yScale", type="float")
     */
    private $yScale;

    /**
     * @var string
     *
     * @ORM\Column(name="xOffset", type="float")
     */
    private $xOffset;

    /**
     * @var string
     *
     * @ORM\Column(name="yOffset", type="float")
     */
    private $yOffset;

    /**
     * @var string
     *
     * @ORM\Column(name="backSoft", type="float")
     */
    private $backSoft;

    /**
     * @var string
     *
     * @ORM\Column(name="backOpacity", type="float")
     */
    private $backOpacity;

    /**
     * @var string
     *
     * @ORM\Column(name="backColor", type="string", length=15)y")
     */
    private $backColor;

    /**
     * @var int
     *
     * @ORM\Column(name="backColorAlpha", type="smallint")
     */
    private $backColorAlpha;

    /**
     * @var bool
     *
     * @ORM\Column(name="kern", type="boolean")
     */
    private $kern;

    /**
     * @var bool
     *
     * @ORM\Column(name="crop", type="boolean")
     */
    private $crop;


        /** @ORM\ManyToOne(targetEntity="AppBundle\Entity\User") */
        protected $user;

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return FCP7Param
     */
    public function setName($name)
    {
        $this->name = $name;

        return $this;
    }

    /**
     * Get name
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set typo
     *
     * @param string $typo
     * @return FCP7Param
     */
    public function setTypo($typo)
    {
        $this->typo = $typo;

        return $this;
    }

    /**
     * Get typo
     *
     * @return string 
     */
    public function getTypo()
    {
        return $this->typo;
    }


    /**
     * Set customTypo
     *
     * @param string $customTypo
     * @return FCP7Param
     */
    public function setCustomTypo($customTypo)
    {
        $this->customTypo = $customTypo;

        return $this;
    }

    /**
     * Get customTypo
     *
     * @return string 
     */
    public function getCustomTypo()
    {
        return $this->customTypo;
    }


    /**
     * Set textSize
     *
     * @param string $textSize
     * @return FCP7Param
     */
    public function setTextSize($textSize)
    {
        $this->textSize = $textSize;

        return $this;
    }

    /**
     * Get textSize
     *
     * @return string 
     */
    public function getTextSize()
    {
        return $this->textSize;
    }

    /**
     * Set textStyle
     *
     * @param integer $textStyle
     * @return FCP7Param
     */
    public function setTextStyle($textStyle)
    {
        $this->textStyle = $textStyle;

        return $this;
    }

    /**
     * Get textStyle
     *
     * @return integer 
     */
    public function getTextStyle()
    {
        return $this->textStyle;
    }

    /**
     * Set alignment
     *
     * @param integer $alignment
     * @return FCP7Param
     */
    public function setAlignment($alignment)
    {
        $this->alignment = $alignment;

        return $this;
    }

    /**
     * Get alignment
     *
     * @return integer 
     */
    public function getAlignment()
    {
        return $this->alignment;
    }

    /**
     * Set tracking
     *
     * @param string $tracking
     * @return FCP7Param
     */
    public function setTracking($tracking)
    {
        $this->tracking = $tracking;

        return $this;
    }

    /**
     * Get tracking
     *
     * @return string 
     */
    public function getTracking()
    {
        return $this->tracking;
    }

    /**
     * Set textLeading
     *
     * @param string $textLeading
     * @return FCP7Param
     */
    public function setTextLeading($textLeading)
    {
        $this->textLeading = $textLeading;

        return $this;
    }

    /**
     * Get textLeading
     *
     * @return string 
     */
    public function getTextLeading()
    {
        return $this->textLeading;
    }

    /**
     * Set aspect
     *
     * @param string $aspect
     * @return FCP7Param
     */
    public function setAspect($aspect)
    {
        $this->aspect = $aspect;

        return $this;
    }

    /**
     * Get aspect
     *
     * @return string 
     */
    public function getAspect()
    {
        return $this->aspect;
    }

    /**
     * Set textOpacity
     *
     * @param string $textOpacity
     * @return FCP7Param
     */
    public function setTextOpacity($textOpacity)
    {
        $this->textOpacity = $textOpacity;

        return $this;
    }

    /**
     * Get textOpacity
     *
     * @return string 
     */
    public function getTextOpacity()
    {
        return $this->textOpacity;
    }

    /**
     * Set sameLine
     *
     * @param boolean $sameLine
     * @return FCP7Param
     */
    public function setSameLine($sameLine)
    {
        $this->sameLine = $sameLine;

        return $this;
    }

    /**
     * Get sameLine
     *
     * @return boolean 
     */
    public function getSameLine()
    {
        return $this->sameLine;
    }


    /**
     * Set centerXone
     *
     * @param string $centerXone
     * @return FCP7Param
     */
    public function setCenterXone($centerXone)
    {
        $this->centerXone = $centerXone;

        return $this;
    }

    /**
     * Get centerXone
     *
     * @return string
     */
    public function getCenterXone()
    {
        return $this->centerXone;
    }


     /**
     * Set centerYone
     *
     * @param string $centerYone
     * @return FCP7Param
     */
    public function setCenterYone($centerYone)
    {
        $this->centerYone = $centerYone;

        return $this;
    }

    /**
     * Get centerYone
     *
     * @return string
     */
    public function getCenterYone()
    {
        return $this->centerYone;
    }




    /**
     * Set centerXtwo
     *
     * @param string $centerXtwo
     * @return FCP7Param
     */
    public function setCenterXtwo($centerXtwo)
    {
        $this->centerXtwo = $centerXtwo;

        return $this;
    }

    /**
     * Get centerXtwo
     *
     * @return string
     */
    public function getCenterXtwo()
    {
        return $this->centerXtwo;
    }


     /**
     * Set centerYtwo
     *
     * @param string $centerYtwo
     * @return FCP7Param
     */
    public function setCenterYtwo($centerYtwo)
    {
        $this->centerYtwo = $centerYtwo;

        return $this;
    }

    /**
     * Get centerYtwo
     *
     * @return string
     */
    public function getCenterYtwo()
    {
        return $this->centerYtwo;
    }


    /**
     * Set textColor
     *
     * @param string $textColor
     * @return FCP7Param
     */
    public function setTextColor($textColor)
    {
        $this->textColor = $textColor;

        return $this;
    }

    /**
     * Get textColor
     *
     * @return string 
     */
    public function getTextColor()
    {
        return $this->textColor;
    }

    /**
     * Set colorAlpha
     *
     * @param integer $colorAlpha
     * @return FCP7Param
     */
    public function setColorAlpha($colorAlpha)
    {
        $this->colorAlpha = $colorAlpha;

        return $this;
    }

    /**
     * Get colorAlpha
     *
     * @return integer 
     */
    public function getColorAlpha()
    {
        return $this->colorAlpha;
    }

    /**
     * Set lineWidth
     *
     * @param string $lineWidth
     * @return FCP7Param
     */
    public function setLineWidth($lineWidth)
    {
        $this->lineWidth = $lineWidth;

        return $this;
    }

    /**
     * Get lineWidth
     *
     * @return string 
     */
    public function getLineWidth()
    {
        return $this->lineWidth;
    }

    /**
     * Set lineSoftness
     *
     * @param string $lineSoftness
     * @return FCP7Param
     */
    public function setLineSoftness($lineSoftness)
    {
        $this->lineSoftness = $lineSoftness;

        return $this;
    }

    /**
     * Get lineSoftness
     *
     * @return string 
     */
    public function getLineSoftness()
    {
        return $this->lineSoftness;
    }

    /**
     * Set outColor
     *
     * @param string $outColor
     * @return FCP7Param
     */
    public function setOutColor($outColor)
    {
        $this->outColor = $outColor;

        return $this;
    }

    /**
     * Get outColor
     *
     * @return string 
     */
    public function getOutColor()
    {
        return $this->outColor;
    }

    /**
     * Set outColorAlpha
     *
     * @param integer $outColorAlpha
     * @return FCP7Param
     */
    public function setOutColorAlpha($outColorAlpha)
    {
        $this->outColorAlpha = $outColorAlpha;

        return $this;
    }

    /**
     * Get outColorAlpha
     *
     * @return integer 
     */
    public function getOutColorAlpha()
    {
        return $this->outColorAlpha;
    }

    /**
     * Set xScale
     *
     * @param string $xScale
     * @return FCP7Param
     */
    public function setXScale($xScale)
    {
        $this->xScale = $xScale;

        return $this;
    }

    /**
     * Get xScale
     *
     * @return string 
     */
    public function getXScale()
    {
        return $this->xScale;
    }

    /**
     * Set yScale
     *
     * @param string $yScale
     * @return FCP7Param
     */
    public function setYScale($yScale)
    {
        $this->yScale = $yScale;

        return $this;
    }

    /**
     * Get yScale
     *
     * @return string 
     */
    public function getYScale()
    {
        return $this->yScale;
    }

    /**
     * Set xOffset
     *
     * @param string $xOffset
     * @return FCP7Param
     */
    public function setXOffset($xOffset)
    {
        $this->xOffset = $xOffset;

        return $this;
    }

    /**
     * Get xOffset
     *
     * @return string 
     */
    public function getXOffset()
    {
        return $this->xOffset;
    }

    /**
     * Set yOffset
     *
     * @param string $yOffset
     * @return FCP7Param
     */
    public function setYOffset($yOffset)
    {
        $this->yOffset = $yOffset;

        return $this;
    }

    /**
     * Get yOffset
     *
     * @return string 
     */
    public function getYOffset()
    {
        return $this->yOffset;
    }

    /**
     * Set backSoft
     *
     * @param string $backSoft
     * @return FCP7Param
     */
    public function setBackSoft($backSoft)
    {
        $this->backSoft = $backSoft;

        return $this;
    }

    /**
     * Get backSoft
     *
     * @return string 
     */
    public function getBackSoft()
    {
        return $this->backSoft;
    }

    /**
     * Set backOpacity
     *
     * @param string $backOpacity
     * @return FCP7Param
     */
    public function setBackOpacity($backOpacity)
    {
        $this->backOpacity = $backOpacity;

        return $this;
    }

    /**
     * Get backOpacity
     *
     * @return string 
     */
    public function getBackOpacity()
    {
        return $this->backOpacity;
    }

    /**
     * Set backColor
     *
     * @param string $backColor
     * @return FCP7Param
     */
    public function setBackColor($backColor)
    {
        $this->backColor = $backColor;

        return $this;
    }

    /**
     * Get backColor
     *
     * @return string 
     */
    public function getBackColor()
    {
        return $this->backColor;
    }

    /**
     * Set backColorAlpha
     *
     * @param integer $backColorAlpha
     * @return FCP7Param
     */
    public function setBackColorAlpha($backColorAlpha)
    {
        $this->backColorAlpha = $backColorAlpha;

        return $this;
    }

    /**
     * Get backColorAlpha
     *
     * @return integer 
     */
    public function getBackColorAlpha()
    {
        return $this->backColorAlpha;
    }

    /**
     * Set kern
     *
     * @param boolean $kern
     * @return FCP7Param
     */
    public function setKern($kern)
    {
        $this->kern = $kern;

        return $this;
    }

    /**
     * Get kern
     *
     * @return boolean 
     */
    public function getKern()
    {
        return $this->kern;
    }

    /**
     * Set crop
     *
     * @param boolean $crop
     * @return FCP7Param
     */
    public function setCrop($crop)
    {
        $this->crop = $crop;

        return $this;
    }

    /**
     * Get crop
     *
     * @return boolean 
     */
    public function getCrop()
    {
        return $this->crop;
    }

     /**
     * @param User $user
     */
    public function setUser(User $user)
    {
        $this->user = $user;
    }

    /**
     * @return user
     */
    public function getUser()
    {
        return $this->user;
    }


    public function __toString()
    {
      return $this->getName();
    }

}
