<?php
// src/AppBundle/Entity/User.php

namespace AppBundle\Entity;

use FOS\UserBundle\Entity\User as BaseUser;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity
 * @ORM\Table(name="fos_user")
 */
class User extends BaseUser
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;


     /**
     * @Assert\Length(
     *     min=6,
     *     max=255,
     *     minMessage="The username must have at least {{ limit }} characters.",
     *     maxMessage="The password must not have most than {{ limit }} characters."
     *    )
     * 
     * 
     */
    protected $username;


    /**
     * @Assert\Length(
     *     min=8,
     *     max=255,
     *     minMessage="The password must have at least {{ limit }} characters.",
     *     maxMessage="The password must not have more than {{ limit }} characters."
     *     )
     */
    protected $plainPassword;
    


    public function __construct()
    {
        parent::__construct();
        // your own logic
    }
}