<?php
namespace AppBundle\Model\SubsFormat;

use AppBundle\Model\SubsFormat\FormatFCPX;
use AppBundle\Model\SubsFormat\Subtitle as Subtitle;


class FormatFCPXv1_1 extends FormatFCPX
{

   
    public function __construct($file=null) {
        parent::__construct($file);
        if ($file !== null) $this->loadFile($this->file);
    }
   
    
    public function getSubtitlesList(){
        
        $titlesTag = $this->xml->getElementsByTagName("title");

        $count = 1;
        foreach($titlesTag as $title)
        {
            $id = $count; 

            $text = $title->getElementsByTagName("text");

            $offset = $title->getAttribute('offset');
            $duration = $title->getAttribute('duration');

            $tcIn = $this->convertTcIn($offset, $this->frameRate);
            $tcOut = $this->convertTcOut($offset, $duration, $this->frameRate);


            $text = trim($text->item(0)->nodeValue);
            $italic = false;
            
            $this->subtitlesList[] = new Subtitle($id, $tcIn, $tcOut, $text, $italic);
            $count += 1;
        }

        return $this->subtitlesList;
    
    }


     public function createNewFile() 
    {

        $path = __DIR__.'/../../../../web/files/fcpX1_1_timeline_buit_hd.fcpxml';



        $file = new \DOMDocument();
        $file -> formatOutput = TRUE;
        $file -> preserveWhiteSpace = FALSE;
        $file -> load($path);
        $file -> formatOutput = TRUE;



    }
}