<?php
namespace AppBundle\Model\SubsFormat;

use AppBundle\Model\SubsFormat\FormatFCPX;
use AppBundle\Model\SubsFormat\Subtitle as Subtitle;



class FormatFCPXv1_3 extends FormatFCPX
{

   
     public function __construct($file=null) {
        parent::__construct($file);
        if ($file !== null) $this->loadFile($this->file);
    }

   
    
    public function getSubtitlesList(){

        $titlesTag = $this->xml->getElementsByTagName("title");

        $count = 1;

        foreach($titlesTag as $title)
        {
            $id = $count; 

            $text = $title->getElementsByTagName("text");
            $textStyleDef = $title->getElementsByTagName("text-style-def")->item(0)->getElementsByTagName("text-style");

            $offset = $title->getAttribute('offset');
            $duration = $title->getAttribute('duration');

            $tcIn = $this->convertTcIn($offset, $this->frameRate);
            $tcOut = $this->convertTcOut($offset, $duration, $this->frameRate);

            $text = trim($text->item(0)->getElementsByTagName('text-style')->item(0)->nodeValue);

            if ($textStyleDef->item(0)->hasAttribute('italic') && $textStyleDef->item(0)->getAttribute('italic') == '1') {
                $italic = true;
            } else{
               $italic = false;
            }
            $this->subtitlesList[] = new Subtitle($id, $tcIn, $tcOut, $text, $italic);
            $count += 1;
        }

        return $this->subtitlesList;
    
    }

     public  function createNewFile() {
        //CODE COMING SOON!!!
     }    
}