// JavaScript Document



/* CHECK FIELDS WHEN USER FOCUS OUT */

$(document).on("focusout", "#form :input:text", function (e) {

	if (!$(e.target).is(".especial")) {
		
		var $listItem = $(this).parents('li:first');

		if (this.value == '') 
		{
				var errorMissatge = "* This fiels is required. It can not be empty.";	 
				writeErrorField($listItem, errorMissatge);
		}	
		else if (isNaN(this.value))
		{
			var errorMissatge = "* You must enter a number. Separate the decimals with a dot.";	 
			writeErrorField($listItem, errorMissatge);
		} 
		else if (this.value > parseInt($(this).attr("max")) || this.value < parseInt($(this).attr("min")))
		{
		
			var errorMissatge = "* The range of values is between " + ($(this).attr("min")) + " and " + $(this).attr("max") + ".";
			writeErrorField($listItem, errorMissatge);		
		}
	}

});

/* DELETE ERROR WHEN FOCUS IN  */

$("form :input").not(".especial").focus(function() {
	$(this).next('span.error').remove();
});

$(document).on("focusin", "#form :input:text", function (e) {
	if (!$(e.target).is(".especial")) {
		$(this).next('span.error').remove();
	}
});


function writeErrorField($listItem, errorMessage) {
	
	$('<span></span>').addClass('error').text(errorMessage).appendTo($listItem);

}

function writeErrorSubmit($listItem, errorMessage) {

	$listItem.addClass('alert alert-danger lead');
	$('<p></p>').text("Attention:").css({'font-weight': 'bold'}).appendTo($listItem);
	
	for (x = 0; x < errorMessage.length; x++) 
	{
		$('<p></p>').text(errorMessage[x]).appendTo($listItem);
	}
}

function checkErrors()
{ 	
	$('.errorMessage p').remove();
	$listItem = $('.errorMessage');

	var errorMessage = new Array();
	var n = 0;
	var count = $('.error').length;
	if (count == 1) {
		errorMessage[n] = "There is one incorrect field.";
		n += 1;
	}
	if (count > 1) {
		errorMessage[n] = "There are " + count + " incorrect fields.";
		n += 1;
	}	

	if ($("#form_subtitleFile").length >= 1 && !$("#form_subtitleFile").val() && !$("#refAutoFile").is(':checked')) {
		errorMessage[n] = "In file options, reference file is missing and generating a new file is not selected. Choose one of them.";
		n += 1;
	}
	
	if (($("#form_subtitleFile").val()) && $("#refAutoFile").is(':checked')) {
		errorMessage[n] = "In file options, a file is uploaded and generating a new file option is selected. Choose only one of them.";
		n += 1;
	}
	
	if (errorMessage.length > 0) {
		writeErrorSubmit($listItem, errorMessage);
	} else {
		$listItem.removeClass('alert alert-danger lead');
		return 0;
	}		
}



function numberStyleSettingsErrors()
{ 	
	var count = $('.error').length;
	var number = (count>0) ?  count :  0;
	return number;
}

